// Code generated by girgen. DO NOT EDIT.

package gtk

import (
	"runtime"
	"unsafe"

	externglib "github.com/diamondburned/gotk4/pkg/core/glib"
)

// #cgo pkg-config: gtk4
// #cgo CFLAGS: -Wno-deprecated-declarations
// #include <glib-object.h>
// #include <gtk/gtk.h>
import "C"

func init() {
	externglib.RegisterGValueMarshalers([]externglib.TypeMarshaler{
		{T: externglib.Type(C.gtk_search_entry_get_type()), F: marshalSearchEntrier},
	})
}

// SearchEntry: GtkSearchEntry is an entry widget that has been tailored for use
// as a search entry.
//
// The main API for interacting with a GtkSearchEntry as entry is the
// GtkEditable interface.
//
// !An example GtkSearchEntry (search-entry.png)
//
// It will show an inactive symbolic “find” icon when the search entry is empty,
// and a symbolic “clear” icon when there is text. Clicking on the “clear” icon
// will empty the search entry.
//
// To make filtering appear more reactive, it is a good idea to not react to
// every change in the entry text immediately, but only after a short delay. To
// support this, GtkSearchEntry emits the gtk.SearchEntry::search-changed signal
// which can be used instead of the gtk.Editable::changed signal.
//
// The gtk.SearchEntry::previous-match, gtk.SearchEntry::next-match and
// gtk.SearchEntry::stop-search signals can be used to implement moving between
// search results and ending the search.
//
// Often, GtkSearchEntry will be fed events by means of being placed inside a
// gtk.SearchBar. If that is not the case, you can use
// gtk.SearchEntry.SetKeyCaptureWidget() to let it capture key input from
// another widget.
//
// GtkSearchEntry provides only minimal API and should be used with the
// gtk.Editable API.
//
// CSS Nodes
//
//    entry.search
//    ╰── text
//
//
// GtkSearchEntry has a single CSS node with name entry that carries a .search
// style class, and the text node is a child of that.
//
//
// Accessibility
//
// GtkSearchEntry uses the GTK_ACCESSIBLE_ROLE_SEARCH_BOX role.
type SearchEntry struct {
	Widget

	Editable
	*externglib.Object
}

func wrapSearchEntry(obj *externglib.Object) *SearchEntry {
	return &SearchEntry{
		Widget: Widget{
			InitiallyUnowned: externglib.InitiallyUnowned{
				Object: obj,
			},
			Accessible: Accessible{
				Object: obj,
			},
			Buildable: Buildable{
				Object: obj,
			},
			ConstraintTarget: ConstraintTarget{
				Object: obj,
			},
			Object: obj,
		},
		Editable: Editable{
			Widget: Widget{
				InitiallyUnowned: externglib.InitiallyUnowned{
					Object: obj,
				},
				Accessible: Accessible{
					Object: obj,
				},
				Buildable: Buildable{
					Object: obj,
				},
				ConstraintTarget: ConstraintTarget{
					Object: obj,
				},
				Object: obj,
			},
		},
		Object: obj,
	}
}

func marshalSearchEntrier(p uintptr) (interface{}, error) {
	return wrapSearchEntry(externglib.ValueFromNative(unsafe.Pointer(p)).Object()), nil
}

// NewSearchEntry creates a GtkSearchEntry.
func NewSearchEntry() *SearchEntry {
	var _cret *C.GtkWidget // in

	_cret = C.gtk_search_entry_new()

	var _searchEntry *SearchEntry // out

	_searchEntry = wrapSearchEntry(externglib.Take(unsafe.Pointer(_cret)))

	return _searchEntry
}

// KeyCaptureWidget gets the widget that entry is capturing key events from.
func (entry *SearchEntry) KeyCaptureWidget() Widgetter {
	var _arg0 *C.GtkSearchEntry // out
	var _cret *C.GtkWidget      // in

	_arg0 = (*C.GtkSearchEntry)(unsafe.Pointer(entry.Native()))

	_cret = C.gtk_search_entry_get_key_capture_widget(_arg0)
	runtime.KeepAlive(entry)

	var _widget Widgetter // out

	{
		objptr := unsafe.Pointer(_cret)
		if objptr == nil {
			panic("object of type gtk.Widgetter is nil")
		}

		object := externglib.Take(objptr)
		rv, ok := (externglib.CastObject(object)).(Widgetter)
		if !ok {
			panic("object of type " + object.TypeFromInstance().String() + " is not gtk.Widgetter")
		}
		_widget = rv
	}

	return _widget
}

// SetKeyCaptureWidget sets widget as the widget that entry will capture key
// events from.
//
// Key events are consumed by the search entry to start or continue a search.
//
// If the entry is part of a GtkSearchBar, it is preferable to call
// gtk.SearchBar.SetKeyCaptureWidget() instead, which will reveal the entry in
// addition to triggering the search entry.
//
// Note that despite the name of this function, the events are only 'captured'
// in the bubble phase, which means that editable child widgets of widget will
// receive text input before it gets captured. If that is not desired, you can
// capture and forward the events yourself with
// gtk.EventControllerKey.Forward().
//
// The function takes the following parameters:
//
//    - widget: Widget.
//
func (entry *SearchEntry) SetKeyCaptureWidget(widget Widgetter) {
	var _arg0 *C.GtkSearchEntry // out
	var _arg1 *C.GtkWidget      // out

	_arg0 = (*C.GtkSearchEntry)(unsafe.Pointer(entry.Native()))
	if widget != nil {
		_arg1 = (*C.GtkWidget)(unsafe.Pointer(widget.Native()))
	}

	C.gtk_search_entry_set_key_capture_widget(_arg0, _arg1)
	runtime.KeepAlive(entry)
	runtime.KeepAlive(widget)
}

// ConnectActivate: emitted when the entry is activated.
//
// The keybindings for this signal are all forms of the Enter key.
func (entry *SearchEntry) ConnectActivate(f func()) externglib.SignalHandle {
	return entry.Connect("activate", f)
}

// ConnectNextMatch: emitted when the user initiates a move to the next match
// for the current search string.
//
// This is a keybinding signal (class.SignalAction.html).
//
// Applications should connect to it, to implement moving between matches.
//
// The default bindings for this signal is Ctrl-g.
func (entry *SearchEntry) ConnectNextMatch(f func()) externglib.SignalHandle {
	return entry.Connect("next-match", f)
}

// ConnectPreviousMatch: emitted when the user initiates a move to the previous
// match for the current search string.
//
// This is a keybinding signal (class.SignalAction.html).
//
// Applications should connect to it, to implement moving between matches.
//
// The default bindings for this signal is Ctrl-Shift-g.
func (entry *SearchEntry) ConnectPreviousMatch(f func()) externglib.SignalHandle {
	return entry.Connect("previous-match", f)
}

// ConnectSearchChanged: emitted with a short delay of 150 milliseconds after
// the last change to the entry text.
func (entry *SearchEntry) ConnectSearchChanged(f func()) externglib.SignalHandle {
	return entry.Connect("search-changed", f)
}

// ConnectSearchStarted: emitted when the user initiated a search on the entry.
func (entry *SearchEntry) ConnectSearchStarted(f func()) externglib.SignalHandle {
	return entry.Connect("search-started", f)
}

// ConnectStopSearch: emitted when the user stops a search via keyboard input.
//
// This is a keybinding signal (class.SignalAction.html).
//
// Applications should connect to it, to implement hiding the search entry in
// this case.
//
// The default bindings for this signal is Escape.
func (entry *SearchEntry) ConnectStopSearch(f func()) externglib.SignalHandle {
	return entry.Connect("stop-search", f)
}
