// Code generated by girgen. DO NOT EDIT.

package pango

import (
	"fmt"
	"runtime"
	"strings"
	"unsafe"

	"github.com/diamondburned/gotk4/pkg/core/gextras"
	externglib "github.com/diamondburned/gotk4/pkg/core/glib"
)

// #cgo pkg-config: pango
// #cgo CFLAGS: -Wno-deprecated-declarations
// #include <glib-object.h>
// #include <pango/pango.h>
import "C"

func init() {
	externglib.RegisterGValueMarshalers([]externglib.TypeMarshaler{
		{T: externglib.Type(C.pango_stretch_get_type()), F: marshalStretch},
		{T: externglib.Type(C.pango_style_get_type()), F: marshalStyle},
		{T: externglib.Type(C.pango_variant_get_type()), F: marshalVariant},
		{T: externglib.Type(C.pango_weight_get_type()), F: marshalWeight},
		{T: externglib.Type(C.pango_font_mask_get_type()), F: marshalFontMask},
		{T: externglib.Type(C.pango_font_get_type()), F: marshalFonter},
		{T: externglib.Type(C.pango_font_face_get_type()), F: marshalFontFacer},
		{T: externglib.Type(C.pango_font_family_get_type()), F: marshalFontFamilier},
		{T: externglib.Type(C.pango_font_description_get_type()), F: marshalFontDescription},
		{T: externglib.Type(C.pango_font_metrics_get_type()), F: marshalFontMetrics},
	})
}

// Stretch: enumeration specifying the width of the font relative to other
// designs within a family.
type Stretch int

const (
	// StretchUltraCondensed: ultra condensed width.
	StretchUltraCondensed Stretch = iota
	// StretchExtraCondensed: extra condensed width.
	StretchExtraCondensed
	// StretchCondensed: condensed width.
	StretchCondensed
	// StretchSemiCondensed: semi condensed width.
	StretchSemiCondensed
	// StretchNormal: normal width.
	StretchNormal
	// StretchSemiExpanded: semi expanded width.
	StretchSemiExpanded
	// StretchExpanded: expanded width.
	StretchExpanded
	// StretchExtraExpanded: extra expanded width.
	StretchExtraExpanded
	// StretchUltraExpanded: ultra expanded width.
	StretchUltraExpanded
)

func marshalStretch(p uintptr) (interface{}, error) {
	return Stretch(externglib.ValueFromNative(unsafe.Pointer(p)).Enum()), nil
}

// String returns the name in string for Stretch.
func (s Stretch) String() string {
	switch s {
	case StretchUltraCondensed:
		return "UltraCondensed"
	case StretchExtraCondensed:
		return "ExtraCondensed"
	case StretchCondensed:
		return "Condensed"
	case StretchSemiCondensed:
		return "SemiCondensed"
	case StretchNormal:
		return "Normal"
	case StretchSemiExpanded:
		return "SemiExpanded"
	case StretchExpanded:
		return "Expanded"
	case StretchExtraExpanded:
		return "ExtraExpanded"
	case StretchUltraExpanded:
		return "UltraExpanded"
	default:
		return fmt.Sprintf("Stretch(%d)", s)
	}
}

// Style: enumeration specifying the various slant styles possible for a font.
type Style int

const (
	// StyleNormal: font is upright.
	StyleNormal Style = iota
	// StyleOblique: font is slanted, but in a roman style.
	StyleOblique
	// StyleItalic: font is slanted in an italic style.
	StyleItalic
)

func marshalStyle(p uintptr) (interface{}, error) {
	return Style(externglib.ValueFromNative(unsafe.Pointer(p)).Enum()), nil
}

// String returns the name in string for Style.
func (s Style) String() string {
	switch s {
	case StyleNormal:
		return "Normal"
	case StyleOblique:
		return "Oblique"
	case StyleItalic:
		return "Italic"
	default:
		return fmt.Sprintf("Style(%d)", s)
	}
}

// Variant: enumeration specifying capitalization variant of the font.
type Variant int

const (
	// VariantNormal: normal font.
	VariantNormal Variant = iota
	// VariantSmallCaps: font with the lower case characters replaced by smaller
	// variants of the capital characters.
	VariantSmallCaps
)

func marshalVariant(p uintptr) (interface{}, error) {
	return Variant(externglib.ValueFromNative(unsafe.Pointer(p)).Enum()), nil
}

// String returns the name in string for Variant.
func (v Variant) String() string {
	switch v {
	case VariantNormal:
		return "Normal"
	case VariantSmallCaps:
		return "SmallCaps"
	default:
		return fmt.Sprintf("Variant(%d)", v)
	}
}

// Weight: enumeration specifying the weight (boldness) of a font.
//
// This is a numerical value ranging from 100 to 1000, but there are some
// predefined values.
type Weight int

const (
	// WeightThin: thin weight (= 100; Since: 1.24).
	WeightThin Weight = 100
	// WeightUltralight: ultralight weight (= 200).
	WeightUltralight Weight = 200
	// WeightLight: light weight (= 300).
	WeightLight Weight = 300
	// WeightSemilight: semilight weight (= 350; Since: 1.36.7).
	WeightSemilight Weight = 350
	// WeightBook: book weight (= 380; Since: 1.24).
	WeightBook Weight = 380
	// WeightNormal: default weight (= 400).
	WeightNormal Weight = 400
	// WeightMedium: normal weight (= 500; Since: 1.24).
	WeightMedium Weight = 500
	// WeightSemibold: semibold weight (= 600).
	WeightSemibold Weight = 600
	// WeightBold: bold weight (= 700).
	WeightBold Weight = 700
	// WeightUltrabold: ultrabold weight (= 800).
	WeightUltrabold Weight = 800
	// WeightHeavy: heavy weight (= 900).
	WeightHeavy Weight = 900
	// WeightUltraheavy: ultraheavy weight (= 1000; Since: 1.24).
	WeightUltraheavy Weight = 1000
)

func marshalWeight(p uintptr) (interface{}, error) {
	return Weight(externglib.ValueFromNative(unsafe.Pointer(p)).Enum()), nil
}

// String returns the name in string for Weight.
func (w Weight) String() string {
	switch w {
	case WeightThin:
		return "Thin"
	case WeightUltralight:
		return "Ultralight"
	case WeightLight:
		return "Light"
	case WeightSemilight:
		return "Semilight"
	case WeightBook:
		return "Book"
	case WeightNormal:
		return "Normal"
	case WeightMedium:
		return "Medium"
	case WeightSemibold:
		return "Semibold"
	case WeightBold:
		return "Bold"
	case WeightUltrabold:
		return "Ultrabold"
	case WeightHeavy:
		return "Heavy"
	case WeightUltraheavy:
		return "Ultraheavy"
	default:
		return fmt.Sprintf("Weight(%d)", w)
	}
}

// FontMask bits in a PangoFontMask correspond to the set fields in a
// PangoFontDescription.
type FontMask int

const (
	// FontMaskFamily: font family is specified.
	FontMaskFamily FontMask = 0b1
	// FontMaskStyle: font style is specified.
	FontMaskStyle FontMask = 0b10
	// FontMaskVariant: font variant is specified.
	FontMaskVariant FontMask = 0b100
	// FontMaskWeight: font weight is specified.
	FontMaskWeight FontMask = 0b1000
	// FontMaskStretch: font stretch is specified.
	FontMaskStretch FontMask = 0b10000
	// FontMaskSize: font size is specified.
	FontMaskSize FontMask = 0b100000
	// FontMaskGravity: font gravity is specified (Since: 1.16.).
	FontMaskGravity FontMask = 0b1000000
	// FontMaskVariations: openType font variations are specified (Since: 1.42).
	FontMaskVariations FontMask = 0b10000000
)

func marshalFontMask(p uintptr) (interface{}, error) {
	return FontMask(externglib.ValueFromNative(unsafe.Pointer(p)).Flags()), nil
}

// String returns the names in string for FontMask.
func (f FontMask) String() string {
	if f == 0 {
		return "FontMask(0)"
	}

	var builder strings.Builder
	builder.Grow(123)

	for f != 0 {
		next := f & (f - 1)
		bit := f - next

		switch bit {
		case FontMaskFamily:
			builder.WriteString("Family|")
		case FontMaskStyle:
			builder.WriteString("Style|")
		case FontMaskVariant:
			builder.WriteString("Variant|")
		case FontMaskWeight:
			builder.WriteString("Weight|")
		case FontMaskStretch:
			builder.WriteString("Stretch|")
		case FontMaskSize:
			builder.WriteString("Size|")
		case FontMaskGravity:
			builder.WriteString("Gravity|")
		case FontMaskVariations:
			builder.WriteString("Variations|")
		default:
			builder.WriteString(fmt.Sprintf("FontMask(0b%b)|", bit))
		}

		f = next
	}

	return strings.TrimSuffix(builder.String(), "|")
}

// Has returns true if f contains other.
func (f FontMask) Has(other FontMask) bool {
	return (f & other) == other
}

// FontOverrider contains methods that are overridable.
//
// As of right now, interface overriding and subclassing is not supported
// yet, so the interface currently has no use.
type FontOverrider interface {
	// Describe returns a description of the font, with font size set in points.
	//
	// Use pango.Font.DescribeWithAbsoluteSize() if you want the font size in
	// device units.
	Describe() *FontDescription
	DescribeAbsolute() *FontDescription
	// Coverage computes the coverage map for a given font and language tag.
	Coverage(language *Language) *Coverage
	// FontMap gets the font map for which the font was created.
	//
	// Note that the font maintains a *weak* reference to the font map, so if
	// all references to font map are dropped, the font map will be finalized
	// even if there are fonts created with the font map that are still alive.
	// In that case this function will return NULL.
	//
	// It is the responsibility of the user to ensure that the font map is kept
	// alive. In most uses this is not an issue as a Context holds a reference
	// to the font map.
	FontMap() FontMapper
	// GlyphExtents gets the logical and ink extents of a glyph within a font.
	//
	// The coordinate system for each rectangle has its origin at the base line
	// and horizontal origin of the character with increasing coordinates
	// extending to the right and down. The macros PANGO_ASCENT(),
	// PANGO_DESCENT(), PANGO_LBEARING(), and PANGO_RBEARING() can be used to
	// convert from the extents rectangle to more traditional font metrics. The
	// units of the rectangles are in 1/PANGO_SCALE of a device unit.
	//
	// If font is NULL, this function gracefully sets some sane values in the
	// output variables and returns.
	GlyphExtents(glyph Glyph) (inkRect Rectangle, logicalRect Rectangle)
	// Metrics gets overall metric information for a font.
	//
	// Since the metrics may be substantially different for different scripts, a
	// language tag can be provided to indicate that the metrics should be
	// retrieved that correspond to the script(s) used by that language.
	//
	// If font is NULL, this function gracefully sets some sane values in the
	// output variables and returns.
	Metrics(language *Language) *FontMetrics
}

// Font: PangoFont is used to represent a font in a rendering-system-independent
// manner.
type Font struct {
	*externglib.Object
}

// Fonter describes Font's abstract methods.
type Fonter interface {
	externglib.Objector

	// Describe returns a description of the font, with font size set in points.
	Describe() *FontDescription
	// DescribeWithAbsoluteSize returns a description of the font, with absolute
	// font size set in device units.
	DescribeWithAbsoluteSize() *FontDescription
	// Coverage computes the coverage map for a given font and language tag.
	Coverage(language *Language) *Coverage
	// Face gets the PangoFontFace to which font belongs.
	Face() FontFacer
	// FontMap gets the font map for which the font was created.
	FontMap() FontMapper
	// GlyphExtents gets the logical and ink extents of a glyph within a font.
	GlyphExtents(glyph Glyph) (inkRect Rectangle, logicalRect Rectangle)
	// Metrics gets overall metric information for a font.
	Metrics(language *Language) *FontMetrics
	// HasChar returns whether the font provides a glyph for this character.
	HasChar(wc uint32) bool
}

var _ Fonter = (*Font)(nil)

func wrapFont(obj *externglib.Object) *Font {
	return &Font{
		Object: obj,
	}
}

func marshalFonter(p uintptr) (interface{}, error) {
	return wrapFont(externglib.ValueFromNative(unsafe.Pointer(p)).Object()), nil
}

// Describe returns a description of the font, with font size set in points.
//
// Use pango.Font.DescribeWithAbsoluteSize() if you want the font size in device
// units.
func (font *Font) Describe() *FontDescription {
	var _arg0 *C.PangoFont            // out
	var _cret *C.PangoFontDescription // in

	_arg0 = (*C.PangoFont)(unsafe.Pointer(font.Native()))

	_cret = C.pango_font_describe(_arg0)
	runtime.KeepAlive(font)

	var _fontDescription *FontDescription // out

	_fontDescription = (*FontDescription)(gextras.NewStructNative(unsafe.Pointer(_cret)))
	runtime.SetFinalizer(
		gextras.StructIntern(unsafe.Pointer(_fontDescription)),
		func(intern *struct{ C unsafe.Pointer }) {
			C.pango_font_description_free((*C.PangoFontDescription)(intern.C))
		},
	)

	return _fontDescription
}

// DescribeWithAbsoluteSize returns a description of the font, with absolute
// font size set in device units.
//
// Use pango.Font.Describe() if you want the font size in points.
func (font *Font) DescribeWithAbsoluteSize() *FontDescription {
	var _arg0 *C.PangoFont            // out
	var _cret *C.PangoFontDescription // in

	_arg0 = (*C.PangoFont)(unsafe.Pointer(font.Native()))

	_cret = C.pango_font_describe_with_absolute_size(_arg0)
	runtime.KeepAlive(font)

	var _fontDescription *FontDescription // out

	_fontDescription = (*FontDescription)(gextras.NewStructNative(unsafe.Pointer(_cret)))
	runtime.SetFinalizer(
		gextras.StructIntern(unsafe.Pointer(_fontDescription)),
		func(intern *struct{ C unsafe.Pointer }) {
			C.pango_font_description_free((*C.PangoFontDescription)(intern.C))
		},
	)

	return _fontDescription
}

// Coverage computes the coverage map for a given font and language tag.
//
// The function takes the following parameters:
//
//    - language tag.
//
func (font *Font) Coverage(language *Language) *Coverage {
	var _arg0 *C.PangoFont     // out
	var _arg1 *C.PangoLanguage // out
	var _cret *C.PangoCoverage // in

	_arg0 = (*C.PangoFont)(unsafe.Pointer(font.Native()))
	_arg1 = (*C.PangoLanguage)(gextras.StructNative(unsafe.Pointer(language)))

	_cret = C.pango_font_get_coverage(_arg0, _arg1)
	runtime.KeepAlive(font)
	runtime.KeepAlive(language)

	var _coverage *Coverage // out

	_coverage = wrapCoverage(externglib.AssumeOwnership(unsafe.Pointer(_cret)))

	return _coverage
}

// Face gets the PangoFontFace to which font belongs.
func (font *Font) Face() FontFacer {
	var _arg0 *C.PangoFont     // out
	var _cret *C.PangoFontFace // in

	_arg0 = (*C.PangoFont)(unsafe.Pointer(font.Native()))

	_cret = C.pango_font_get_face(_arg0)
	runtime.KeepAlive(font)

	var _fontFace FontFacer // out

	{
		objptr := unsafe.Pointer(_cret)
		if objptr == nil {
			panic("object of type pango.FontFacer is nil")
		}

		object := externglib.Take(objptr)
		rv, ok := (externglib.CastObject(object)).(FontFacer)
		if !ok {
			panic("object of type " + object.TypeFromInstance().String() + " is not pango.FontFacer")
		}
		_fontFace = rv
	}

	return _fontFace
}

// FontMap gets the font map for which the font was created.
//
// Note that the font maintains a *weak* reference to the font map, so if all
// references to font map are dropped, the font map will be finalized even if
// there are fonts created with the font map that are still alive. In that case
// this function will return NULL.
//
// It is the responsibility of the user to ensure that the font map is kept
// alive. In most uses this is not an issue as a Context holds a reference to
// the font map.
func (font *Font) FontMap() FontMapper {
	var _arg0 *C.PangoFont    // out
	var _cret *C.PangoFontMap // in

	if font != nil {
		_arg0 = (*C.PangoFont)(unsafe.Pointer(font.Native()))
	}

	_cret = C.pango_font_get_font_map(_arg0)
	runtime.KeepAlive(font)

	var _fontMap FontMapper // out

	if _cret != nil {
		{
			objptr := unsafe.Pointer(_cret)

			object := externglib.Take(objptr)
			rv, ok := (externglib.CastObject(object)).(FontMapper)
			if !ok {
				panic("object of type " + object.TypeFromInstance().String() + " is not pango.FontMapper")
			}
			_fontMap = rv
		}
	}

	return _fontMap
}

// GlyphExtents gets the logical and ink extents of a glyph within a font.
//
// The coordinate system for each rectangle has its origin at the base line and
// horizontal origin of the character with increasing coordinates extending to
// the right and down. The macros PANGO_ASCENT(), PANGO_DESCENT(),
// PANGO_LBEARING(), and PANGO_RBEARING() can be used to convert from the
// extents rectangle to more traditional font metrics. The units of the
// rectangles are in 1/PANGO_SCALE of a device unit.
//
// If font is NULL, this function gracefully sets some sane values in the output
// variables and returns.
//
// The function takes the following parameters:
//
//    - glyph index.
//
func (font *Font) GlyphExtents(glyph Glyph) (inkRect Rectangle, logicalRect Rectangle) {
	var _arg0 *C.PangoFont     // out
	var _arg1 C.PangoGlyph     // out
	var _arg2 C.PangoRectangle // in
	var _arg3 C.PangoRectangle // in

	if font != nil {
		_arg0 = (*C.PangoFont)(unsafe.Pointer(font.Native()))
	}
	_arg1 = C.guint32(glyph)

	C.pango_font_get_glyph_extents(_arg0, _arg1, &_arg2, &_arg3)
	runtime.KeepAlive(font)
	runtime.KeepAlive(glyph)

	var _inkRect Rectangle     // out
	var _logicalRect Rectangle // out

	_inkRect = *(*Rectangle)(gextras.NewStructNative(unsafe.Pointer((&_arg2))))
	_logicalRect = *(*Rectangle)(gextras.NewStructNative(unsafe.Pointer((&_arg3))))

	return _inkRect, _logicalRect
}

// Metrics gets overall metric information for a font.
//
// Since the metrics may be substantially different for different scripts, a
// language tag can be provided to indicate that the metrics should be retrieved
// that correspond to the script(s) used by that language.
//
// If font is NULL, this function gracefully sets some sane values in the output
// variables and returns.
//
// The function takes the following parameters:
//
//    - language tag used to determine which script to get the metrics for, or
//    NULL to indicate to get the metrics for the entire font.
//
func (font *Font) Metrics(language *Language) *FontMetrics {
	var _arg0 *C.PangoFont        // out
	var _arg1 *C.PangoLanguage    // out
	var _cret *C.PangoFontMetrics // in

	if font != nil {
		_arg0 = (*C.PangoFont)(unsafe.Pointer(font.Native()))
	}
	if language != nil {
		_arg1 = (*C.PangoLanguage)(gextras.StructNative(unsafe.Pointer(language)))
	}

	_cret = C.pango_font_get_metrics(_arg0, _arg1)
	runtime.KeepAlive(font)
	runtime.KeepAlive(language)

	var _fontMetrics *FontMetrics // out

	_fontMetrics = (*FontMetrics)(gextras.NewStructNative(unsafe.Pointer(_cret)))
	runtime.SetFinalizer(
		gextras.StructIntern(unsafe.Pointer(_fontMetrics)),
		func(intern *struct{ C unsafe.Pointer }) {
			C.pango_font_metrics_unref((*C.PangoFontMetrics)(intern.C))
		},
	)

	return _fontMetrics
}

// HasChar returns whether the font provides a glyph for this character.
//
// Returns TRUE if font can render wc.
//
// The function takes the following parameters:
//
//    - wc: unicode character.
//
func (font *Font) HasChar(wc uint32) bool {
	var _arg0 *C.PangoFont // out
	var _arg1 C.gunichar   // out
	var _cret C.gboolean   // in

	_arg0 = (*C.PangoFont)(unsafe.Pointer(font.Native()))
	_arg1 = C.gunichar(wc)

	_cret = C.pango_font_has_char(_arg0, _arg1)
	runtime.KeepAlive(font)
	runtime.KeepAlive(wc)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// FontFaceOverrider contains methods that are overridable.
//
// As of right now, interface overriding and subclassing is not supported
// yet, so the interface currently has no use.
type FontFaceOverrider interface {
	// Describe returns the family, style, variant, weight and stretch of a
	// PangoFontFace. The size field of the resulting font description will be
	// unset.
	Describe() *FontDescription
	// FaceName gets a name representing the style of this face among the
	// different faces in the PangoFontFamily for the face. The name is suitable
	// for displaying to users.
	FaceName() string
	// Family gets the PangoFontFamily that face belongs to.
	Family() FontFamilier
	// IsSynthesized returns whether a PangoFontFace is synthesized by the
	// underlying font rendering engine from another face, perhaps by shearing,
	// emboldening, or lightening it.
	IsSynthesized() bool
	// ListSizes: list the available sizes for a font.
	//
	// This is only applicable to bitmap fonts. For scalable fonts, stores NULL
	// at the location pointed to by sizes and 0 at the location pointed to by
	// n_sizes. The sizes returned are in Pango units and are sorted in
	// ascending order.
	ListSizes() []int
}

// FontFace: PangoFontFace is used to represent a group of fonts with the same
// family, slant, weight, and width, but varying sizes.
type FontFace struct {
	*externglib.Object
}

// FontFacer describes FontFace's abstract methods.
type FontFacer interface {
	externglib.Objector

	// Describe returns the family, style, variant, weight and stretch of a
	// PangoFontFace.
	Describe() *FontDescription
	// FaceName gets a name representing the style of this face among the
	// different faces in the PangoFontFamily for the face.
	FaceName() string
	// Family gets the PangoFontFamily that face belongs to.
	Family() FontFamilier
	// IsSynthesized returns whether a PangoFontFace is synthesized by the
	// underlying font rendering engine from another face, perhaps by shearing,
	// emboldening, or lightening it.
	IsSynthesized() bool
	// ListSizes: list the available sizes for a font.
	ListSizes() []int
}

var _ FontFacer = (*FontFace)(nil)

func wrapFontFace(obj *externglib.Object) *FontFace {
	return &FontFace{
		Object: obj,
	}
}

func marshalFontFacer(p uintptr) (interface{}, error) {
	return wrapFontFace(externglib.ValueFromNative(unsafe.Pointer(p)).Object()), nil
}

// Describe returns the family, style, variant, weight and stretch of a
// PangoFontFace. The size field of the resulting font description will be
// unset.
func (face *FontFace) Describe() *FontDescription {
	var _arg0 *C.PangoFontFace        // out
	var _cret *C.PangoFontDescription // in

	_arg0 = (*C.PangoFontFace)(unsafe.Pointer(face.Native()))

	_cret = C.pango_font_face_describe(_arg0)
	runtime.KeepAlive(face)

	var _fontDescription *FontDescription // out

	_fontDescription = (*FontDescription)(gextras.NewStructNative(unsafe.Pointer(_cret)))
	runtime.SetFinalizer(
		gextras.StructIntern(unsafe.Pointer(_fontDescription)),
		func(intern *struct{ C unsafe.Pointer }) {
			C.pango_font_description_free((*C.PangoFontDescription)(intern.C))
		},
	)

	return _fontDescription
}

// FaceName gets a name representing the style of this face among the different
// faces in the PangoFontFamily for the face. The name is suitable for
// displaying to users.
func (face *FontFace) FaceName() string {
	var _arg0 *C.PangoFontFace // out
	var _cret *C.char          // in

	_arg0 = (*C.PangoFontFace)(unsafe.Pointer(face.Native()))

	_cret = C.pango_font_face_get_face_name(_arg0)
	runtime.KeepAlive(face)

	var _utf8 string // out

	_utf8 = C.GoString((*C.gchar)(unsafe.Pointer(_cret)))

	return _utf8
}

// Family gets the PangoFontFamily that face belongs to.
func (face *FontFace) Family() FontFamilier {
	var _arg0 *C.PangoFontFace   // out
	var _cret *C.PangoFontFamily // in

	_arg0 = (*C.PangoFontFace)(unsafe.Pointer(face.Native()))

	_cret = C.pango_font_face_get_family(_arg0)
	runtime.KeepAlive(face)

	var _fontFamily FontFamilier // out

	{
		objptr := unsafe.Pointer(_cret)
		if objptr == nil {
			panic("object of type pango.FontFamilier is nil")
		}

		object := externglib.Take(objptr)
		rv, ok := (externglib.CastObject(object)).(FontFamilier)
		if !ok {
			panic("object of type " + object.TypeFromInstance().String() + " is not pango.FontFamilier")
		}
		_fontFamily = rv
	}

	return _fontFamily
}

// IsSynthesized returns whether a PangoFontFace is synthesized by the
// underlying font rendering engine from another face, perhaps by shearing,
// emboldening, or lightening it.
func (face *FontFace) IsSynthesized() bool {
	var _arg0 *C.PangoFontFace // out
	var _cret C.gboolean       // in

	_arg0 = (*C.PangoFontFace)(unsafe.Pointer(face.Native()))

	_cret = C.pango_font_face_is_synthesized(_arg0)
	runtime.KeepAlive(face)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// ListSizes: list the available sizes for a font.
//
// This is only applicable to bitmap fonts. For scalable fonts, stores NULL at
// the location pointed to by sizes and 0 at the location pointed to by n_sizes.
// The sizes returned are in Pango units and are sorted in ascending order.
func (face *FontFace) ListSizes() []int {
	var _arg0 *C.PangoFontFace // out
	var _arg1 *C.int           // in
	var _arg2 C.int            // in

	_arg0 = (*C.PangoFontFace)(unsafe.Pointer(face.Native()))

	C.pango_font_face_list_sizes(_arg0, &_arg1, &_arg2)
	runtime.KeepAlive(face)

	var _sizes []int // out

	if _arg1 != nil {
		defer C.free(unsafe.Pointer(_arg1))
		{
			src := unsafe.Slice(_arg1, _arg2)
			_sizes = make([]int, _arg2)
			for i := 0; i < int(_arg2); i++ {
				_sizes[i] = int(src[i])
			}
		}
	}

	return _sizes
}

// FontFamilyOverrider contains methods that are overridable.
//
// As of right now, interface overriding and subclassing is not supported
// yet, so the interface currently has no use.
type FontFamilyOverrider interface {
	// Face gets the PangoFontFace of family with the given name.
	Face(name string) FontFacer
	// Name gets the name of the family.
	//
	// The name is unique among all fonts for the font backend and can be used
	// in a PangoFontDescription to specify that a face from this family is
	// desired.
	Name() string
	// IsMonospace: monospace font is a font designed for text display where the
	// the characters form a regular grid.
	//
	// For Western languages this would mean that the advance width of all
	// characters are the same, but this categorization also includes Asian
	// fonts which include double-width characters: characters that occupy two
	// grid cells. g_unichar_iswide() returns a result that indicates whether a
	// character is typically double-width in a monospace font.
	//
	// The best way to find out the grid-cell size is to call
	// pango.FontMetrics.GetApproximateDigitWidth(), since the results of
	// pango.FontMetrics.GetApproximateCharWidth() may be affected by
	// double-width characters.
	IsMonospace() bool
	// IsVariable: variable font is a font which has axes that can be modified
	// to produce different faces.
	IsVariable() bool
	// ListFaces lists the different font faces that make up family.
	//
	// The faces in a family share a common design, but differ in slant, weight,
	// width and other aspects.
	ListFaces() []FontFacer
}

// FontFamily: PangoFontFamily is used to represent a family of related font
// faces.
//
// The font faces in a family share a common design, but differ in slant,
// weight, width or other aspects.
type FontFamily struct {
	*externglib.Object
}

// FontFamilier describes FontFamily's abstract methods.
type FontFamilier interface {
	externglib.Objector

	// Face gets the PangoFontFace of family with the given name.
	Face(name string) FontFacer
	// Name gets the name of the family.
	Name() string
	// IsMonospace: monospace font is a font designed for text display where the
	// the characters form a regular grid.
	IsMonospace() bool
	// IsVariable: variable font is a font which has axes that can be modified
	// to produce different faces.
	IsVariable() bool
	// ListFaces lists the different font faces that make up family.
	ListFaces() []FontFacer
}

var _ FontFamilier = (*FontFamily)(nil)

func wrapFontFamily(obj *externglib.Object) *FontFamily {
	return &FontFamily{
		Object: obj,
	}
}

func marshalFontFamilier(p uintptr) (interface{}, error) {
	return wrapFontFamily(externglib.ValueFromNative(unsafe.Pointer(p)).Object()), nil
}

// Face gets the PangoFontFace of family with the given name.
//
// The function takes the following parameters:
//
//    - name of a face. If the name is NULL, the family's default face
//    (fontconfig calls it "Regular") will be returned.
//
func (family *FontFamily) Face(name string) FontFacer {
	var _arg0 *C.PangoFontFamily // out
	var _arg1 *C.char            // out
	var _cret *C.PangoFontFace   // in

	_arg0 = (*C.PangoFontFamily)(unsafe.Pointer(family.Native()))
	if name != "" {
		_arg1 = (*C.char)(unsafe.Pointer(C.CString(name)))
		defer C.free(unsafe.Pointer(_arg1))
	}

	_cret = C.pango_font_family_get_face(_arg0, _arg1)
	runtime.KeepAlive(family)
	runtime.KeepAlive(name)

	var _fontFace FontFacer // out

	if _cret != nil {
		{
			objptr := unsafe.Pointer(_cret)

			object := externglib.Take(objptr)
			rv, ok := (externglib.CastObject(object)).(FontFacer)
			if !ok {
				panic("object of type " + object.TypeFromInstance().String() + " is not pango.FontFacer")
			}
			_fontFace = rv
		}
	}

	return _fontFace
}

// Name gets the name of the family.
//
// The name is unique among all fonts for the font backend and can be used in a
// PangoFontDescription to specify that a face from this family is desired.
func (family *FontFamily) Name() string {
	var _arg0 *C.PangoFontFamily // out
	var _cret *C.char            // in

	_arg0 = (*C.PangoFontFamily)(unsafe.Pointer(family.Native()))

	_cret = C.pango_font_family_get_name(_arg0)
	runtime.KeepAlive(family)

	var _utf8 string // out

	_utf8 = C.GoString((*C.gchar)(unsafe.Pointer(_cret)))

	return _utf8
}

// IsMonospace: monospace font is a font designed for text display where the the
// characters form a regular grid.
//
// For Western languages this would mean that the advance width of all
// characters are the same, but this categorization also includes Asian fonts
// which include double-width characters: characters that occupy two grid cells.
// g_unichar_iswide() returns a result that indicates whether a character is
// typically double-width in a monospace font.
//
// The best way to find out the grid-cell size is to call
// pango.FontMetrics.GetApproximateDigitWidth(), since the results of
// pango.FontMetrics.GetApproximateCharWidth() may be affected by double-width
// characters.
func (family *FontFamily) IsMonospace() bool {
	var _arg0 *C.PangoFontFamily // out
	var _cret C.gboolean         // in

	_arg0 = (*C.PangoFontFamily)(unsafe.Pointer(family.Native()))

	_cret = C.pango_font_family_is_monospace(_arg0)
	runtime.KeepAlive(family)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// IsVariable: variable font is a font which has axes that can be modified to
// produce different faces.
func (family *FontFamily) IsVariable() bool {
	var _arg0 *C.PangoFontFamily // out
	var _cret C.gboolean         // in

	_arg0 = (*C.PangoFontFamily)(unsafe.Pointer(family.Native()))

	_cret = C.pango_font_family_is_variable(_arg0)
	runtime.KeepAlive(family)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// ListFaces lists the different font faces that make up family.
//
// The faces in a family share a common design, but differ in slant, weight,
// width and other aspects.
func (family *FontFamily) ListFaces() []FontFacer {
	var _arg0 *C.PangoFontFamily // out
	var _arg1 **C.PangoFontFace  // in
	var _arg2 C.int              // in

	_arg0 = (*C.PangoFontFamily)(unsafe.Pointer(family.Native()))

	C.pango_font_family_list_faces(_arg0, &_arg1, &_arg2)
	runtime.KeepAlive(family)

	var _faces []FontFacer // out

	if _arg1 != nil {
		defer C.free(unsafe.Pointer(_arg1))
		{
			src := unsafe.Slice(_arg1, _arg2)
			_faces = make([]FontFacer, _arg2)
			for i := 0; i < int(_arg2); i++ {
				{
					objptr := unsafe.Pointer(src[i])
					if objptr == nil {
						panic("object of type pango.FontFacer is nil")
					}

					object := externglib.Take(objptr)
					rv, ok := (externglib.CastObject(object)).(FontFacer)
					if !ok {
						panic("object of type " + object.TypeFromInstance().String() + " is not pango.FontFacer")
					}
					_faces[i] = rv
				}
			}
		}
	}

	return _faces
}

// FontDescription: PangoFontDescription describes a font in an
// implementation-independent manner.
//
// PangoFontDescription structures are used both to list what fonts are
// available on the system and also for specifying the characteristics of a font
// to load.
//
// An instance of this type is always passed by reference.
type FontDescription struct {
	*fontDescription
}

// fontDescription is the struct that's finalized.
type fontDescription struct {
	native *C.PangoFontDescription
}

func marshalFontDescription(p uintptr) (interface{}, error) {
	b := externglib.ValueFromNative(unsafe.Pointer(p)).Boxed()
	return &FontDescription{&fontDescription{(*C.PangoFontDescription)(b)}}, nil
}

// NewFontDescription constructs a struct FontDescription.
func NewFontDescription() *FontDescription {
	var _cret *C.PangoFontDescription // in

	_cret = C.pango_font_description_new()

	var _fontDescription *FontDescription // out

	_fontDescription = (*FontDescription)(gextras.NewStructNative(unsafe.Pointer(_cret)))
	runtime.SetFinalizer(
		gextras.StructIntern(unsafe.Pointer(_fontDescription)),
		func(intern *struct{ C unsafe.Pointer }) {
			C.pango_font_description_free((*C.PangoFontDescription)(intern.C))
		},
	)

	return _fontDescription
}

// BetterMatch determines if the style attributes of new_match are a closer
// match for desc than those of old_match are, or if old_match is NULL,
// determines if new_match is a match at all.
//
// Approximate matching is done for weight and style; other style attributes
// must match exactly. Style attributes are all attributes other than family and
// size-related attributes. Approximate matching for style considers
// PANGO_STYLE_OBLIQUE and PANGO_STYLE_ITALIC as matches, but not as good a
// match as when the styles are equal.
//
// Note that old_match must match desc.
func (desc *FontDescription) BetterMatch(oldMatch *FontDescription, newMatch *FontDescription) bool {
	var _arg0 *C.PangoFontDescription // out
	var _arg1 *C.PangoFontDescription // out
	var _arg2 *C.PangoFontDescription // out
	var _cret C.gboolean              // in

	_arg0 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc)))
	if oldMatch != nil {
		_arg1 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(oldMatch)))
	}
	_arg2 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(newMatch)))

	_cret = C.pango_font_description_better_match(_arg0, _arg1, _arg2)
	runtime.KeepAlive(desc)
	runtime.KeepAlive(oldMatch)
	runtime.KeepAlive(newMatch)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// Copy: make a copy of a PangoFontDescription.
func (desc *FontDescription) Copy() *FontDescription {
	var _arg0 *C.PangoFontDescription // out
	var _cret *C.PangoFontDescription // in

	if desc != nil {
		_arg0 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc)))
	}

	_cret = C.pango_font_description_copy(_arg0)
	runtime.KeepAlive(desc)

	var _fontDescription *FontDescription // out

	if _cret != nil {
		_fontDescription = (*FontDescription)(gextras.NewStructNative(unsafe.Pointer(_cret)))
		runtime.SetFinalizer(
			gextras.StructIntern(unsafe.Pointer(_fontDescription)),
			func(intern *struct{ C unsafe.Pointer }) {
				C.pango_font_description_free((*C.PangoFontDescription)(intern.C))
			},
		)
	}

	return _fontDescription
}

// CopyStatic: make a copy of a PangoFontDescription, but don't duplicate
// allocated fields.
//
// This is like pango.FontDescription.Copy(), but only a shallow copy is made of
// the family name and other allocated fields. The result can only be used until
// desc is modified or freed. This is meant to be used when the copy is only
// needed temporarily.
func (desc *FontDescription) CopyStatic() *FontDescription {
	var _arg0 *C.PangoFontDescription // out
	var _cret *C.PangoFontDescription // in

	if desc != nil {
		_arg0 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc)))
	}

	_cret = C.pango_font_description_copy_static(_arg0)
	runtime.KeepAlive(desc)

	var _fontDescription *FontDescription // out

	if _cret != nil {
		_fontDescription = (*FontDescription)(gextras.NewStructNative(unsafe.Pointer(_cret)))
		runtime.SetFinalizer(
			gextras.StructIntern(unsafe.Pointer(_fontDescription)),
			func(intern *struct{ C unsafe.Pointer }) {
				C.pango_font_description_free((*C.PangoFontDescription)(intern.C))
			},
		)
	}

	return _fontDescription
}

// Equal compares two font descriptions for equality.
//
// Two font descriptions are considered equal if the fonts they describe are
// provably identical. This means that their masks do not have to match, as long
// as other fields are all the same. (Two font descriptions may result in
// identical fonts being loaded, but still compare FALSE.).
func (desc1 *FontDescription) Equal(desc2 *FontDescription) bool {
	var _arg0 *C.PangoFontDescription // out
	var _arg1 *C.PangoFontDescription // out
	var _cret C.gboolean              // in

	_arg0 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc1)))
	_arg1 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc2)))

	_cret = C.pango_font_description_equal(_arg0, _arg1)
	runtime.KeepAlive(desc1)
	runtime.KeepAlive(desc2)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// Family gets the family name field of a font description.
//
// See pango.FontDescription.SetFamily().
func (desc *FontDescription) Family() string {
	var _arg0 *C.PangoFontDescription // out
	var _cret *C.char                 // in

	_arg0 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc)))

	_cret = C.pango_font_description_get_family(_arg0)
	runtime.KeepAlive(desc)

	var _utf8 string // out

	if _cret != nil {
		_utf8 = C.GoString((*C.gchar)(unsafe.Pointer(_cret)))
	}

	return _utf8
}

// Gravity gets the gravity field of a font description.
//
// See pango.FontDescription.SetGravity().
func (desc *FontDescription) Gravity() Gravity {
	var _arg0 *C.PangoFontDescription // out
	var _cret C.PangoGravity          // in

	_arg0 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc)))

	_cret = C.pango_font_description_get_gravity(_arg0)
	runtime.KeepAlive(desc)

	var _gravity Gravity // out

	_gravity = Gravity(_cret)

	return _gravity
}

// SetFields determines which fields in a font description have been set.
func (desc *FontDescription) SetFields() FontMask {
	var _arg0 *C.PangoFontDescription // out
	var _cret C.PangoFontMask         // in

	_arg0 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc)))

	_cret = C.pango_font_description_get_set_fields(_arg0)
	runtime.KeepAlive(desc)

	var _fontMask FontMask // out

	_fontMask = FontMask(_cret)

	return _fontMask
}

// Size gets the size field of a font description.
//
// See pango.FontDescription.SetSize().
func (desc *FontDescription) Size() int {
	var _arg0 *C.PangoFontDescription // out
	var _cret C.gint                  // in

	_arg0 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc)))

	_cret = C.pango_font_description_get_size(_arg0)
	runtime.KeepAlive(desc)

	var _gint int // out

	_gint = int(_cret)

	return _gint
}

// SizeIsAbsolute determines whether the size of the font is in points (not
// absolute) or device units (absolute).
//
// See pango.FontDescription.SetSize() and
// pango.FontDescription.SetAbsoluteSize().
func (desc *FontDescription) SizeIsAbsolute() bool {
	var _arg0 *C.PangoFontDescription // out
	var _cret C.gboolean              // in

	_arg0 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc)))

	_cret = C.pango_font_description_get_size_is_absolute(_arg0)
	runtime.KeepAlive(desc)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// Stretch gets the stretch field of a font description.
//
// See pango.FontDescription.SetStretch().
func (desc *FontDescription) Stretch() Stretch {
	var _arg0 *C.PangoFontDescription // out
	var _cret C.PangoStretch          // in

	_arg0 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc)))

	_cret = C.pango_font_description_get_stretch(_arg0)
	runtime.KeepAlive(desc)

	var _stretch Stretch // out

	_stretch = Stretch(_cret)

	return _stretch
}

// Style gets the style field of a PangoFontDescription.
//
// See pango.FontDescription.SetStyle().
func (desc *FontDescription) Style() Style {
	var _arg0 *C.PangoFontDescription // out
	var _cret C.PangoStyle            // in

	_arg0 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc)))

	_cret = C.pango_font_description_get_style(_arg0)
	runtime.KeepAlive(desc)

	var _style Style // out

	_style = Style(_cret)

	return _style
}

// Variant gets the variant field of a PangoFontDescription.
//
// See pango.FontDescription.SetVariant().
func (desc *FontDescription) Variant() Variant {
	var _arg0 *C.PangoFontDescription // out
	var _cret C.PangoVariant          // in

	_arg0 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc)))

	_cret = C.pango_font_description_get_variant(_arg0)
	runtime.KeepAlive(desc)

	var _variant Variant // out

	_variant = Variant(_cret)

	return _variant
}

// Variations gets the variations field of a font description.
//
// See pango.FontDescription.SetVariations().
func (desc *FontDescription) Variations() string {
	var _arg0 *C.PangoFontDescription // out
	var _cret *C.char                 // in

	_arg0 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc)))

	_cret = C.pango_font_description_get_variations(_arg0)
	runtime.KeepAlive(desc)

	var _utf8 string // out

	if _cret != nil {
		_utf8 = C.GoString((*C.gchar)(unsafe.Pointer(_cret)))
	}

	return _utf8
}

// Weight gets the weight field of a font description.
//
// See pango.FontDescription.SetWeight().
func (desc *FontDescription) Weight() Weight {
	var _arg0 *C.PangoFontDescription // out
	var _cret C.PangoWeight           // in

	_arg0 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc)))

	_cret = C.pango_font_description_get_weight(_arg0)
	runtime.KeepAlive(desc)

	var _weight Weight // out

	_weight = Weight(_cret)

	return _weight
}

// Hash computes a hash of a PangoFontDescription structure.
//
// This is suitable to be used, for example, as an argument to
// g_hash_table_new(). The hash value is independent of desc->mask.
func (desc *FontDescription) Hash() uint {
	var _arg0 *C.PangoFontDescription // out
	var _cret C.guint                 // in

	_arg0 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc)))

	_cret = C.pango_font_description_hash(_arg0)
	runtime.KeepAlive(desc)

	var _guint uint // out

	_guint = uint(_cret)

	return _guint
}

// Merge merges the fields that are set in desc_to_merge into the fields in
// desc.
//
// If replace_existing is FALSE, only fields in desc that are not already set
// are affected. If TRUE, then fields that are already set will be replaced as
// well.
//
// If desc_to_merge is NULL, this function performs nothing.
func (desc *FontDescription) Merge(descToMerge *FontDescription, replaceExisting bool) {
	var _arg0 *C.PangoFontDescription // out
	var _arg1 *C.PangoFontDescription // out
	var _arg2 C.gboolean              // out

	_arg0 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc)))
	if descToMerge != nil {
		_arg1 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(descToMerge)))
	}
	if replaceExisting {
		_arg2 = C.TRUE
	}

	C.pango_font_description_merge(_arg0, _arg1, _arg2)
	runtime.KeepAlive(desc)
	runtime.KeepAlive(descToMerge)
	runtime.KeepAlive(replaceExisting)
}

// MergeStatic merges the fields that are set in desc_to_merge into the fields
// in desc, without copying allocated fields.
//
// This is like pango.FontDescription.Merge(), but only a shallow copy is made
// of the family name and other allocated fields. desc can only be used until
// desc_to_merge is modified or freed. This is meant to be used when the merged
// font description is only needed temporarily.
func (desc *FontDescription) MergeStatic(descToMerge *FontDescription, replaceExisting bool) {
	var _arg0 *C.PangoFontDescription // out
	var _arg1 *C.PangoFontDescription // out
	var _arg2 C.gboolean              // out

	_arg0 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc)))
	_arg1 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(descToMerge)))
	if replaceExisting {
		_arg2 = C.TRUE
	}

	C.pango_font_description_merge_static(_arg0, _arg1, _arg2)
	runtime.KeepAlive(desc)
	runtime.KeepAlive(descToMerge)
	runtime.KeepAlive(replaceExisting)
}

// SetAbsoluteSize sets the size field of a font description, in device units.
//
// This is mutually exclusive with pango.FontDescription.SetSize() which sets
// the font size in points.
func (desc *FontDescription) SetAbsoluteSize(size float64) {
	var _arg0 *C.PangoFontDescription // out
	var _arg1 C.double                // out

	_arg0 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc)))
	_arg1 = C.double(size)

	C.pango_font_description_set_absolute_size(_arg0, _arg1)
	runtime.KeepAlive(desc)
	runtime.KeepAlive(size)
}

// SetFamily sets the family name field of a font description.
//
// The family name represents a family of related font styles, and will resolve
// to a particular PangoFontFamily. In some uses of PangoFontDescription, it is
// also possible to use a comma separated list of family names for this field.
func (desc *FontDescription) SetFamily(family string) {
	var _arg0 *C.PangoFontDescription // out
	var _arg1 *C.char                 // out

	_arg0 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc)))
	_arg1 = (*C.char)(unsafe.Pointer(C.CString(family)))
	defer C.free(unsafe.Pointer(_arg1))

	C.pango_font_description_set_family(_arg0, _arg1)
	runtime.KeepAlive(desc)
	runtime.KeepAlive(family)
}

// SetFamilyStatic sets the family name field of a font description, without
// copying the string.
//
// This is like pango.FontDescription.SetFamily(), except that no copy of family
// is made. The caller must make sure that the string passed in stays around
// until desc has been freed or the name is set again. This function can be used
// if family is a static string such as a C string literal, or if desc is only
// needed temporarily.
func (desc *FontDescription) SetFamilyStatic(family string) {
	var _arg0 *C.PangoFontDescription // out
	var _arg1 *C.char                 // out

	_arg0 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc)))
	_arg1 = (*C.char)(unsafe.Pointer(C.CString(family)))
	defer C.free(unsafe.Pointer(_arg1))

	C.pango_font_description_set_family_static(_arg0, _arg1)
	runtime.KeepAlive(desc)
	runtime.KeepAlive(family)
}

// SetGravity sets the gravity field of a font description.
//
// The gravity field specifies how the glyphs should be rotated. If gravity is
// PANGO_GRAVITY_AUTO, this actually unsets the gravity mask on the font
// description.
//
// This function is seldom useful to the user. Gravity should normally be set on
// a PangoContext.
func (desc *FontDescription) SetGravity(gravity Gravity) {
	var _arg0 *C.PangoFontDescription // out
	var _arg1 C.PangoGravity          // out

	_arg0 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc)))
	_arg1 = C.PangoGravity(gravity)

	C.pango_font_description_set_gravity(_arg0, _arg1)
	runtime.KeepAlive(desc)
	runtime.KeepAlive(gravity)
}

// SetSize sets the size field of a font description in fractional points.
//
// This is mutually exclusive with pango.FontDescription.SetAbsoluteSize().
func (desc *FontDescription) SetSize(size int) {
	var _arg0 *C.PangoFontDescription // out
	var _arg1 C.gint                  // out

	_arg0 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc)))
	_arg1 = C.gint(size)

	C.pango_font_description_set_size(_arg0, _arg1)
	runtime.KeepAlive(desc)
	runtime.KeepAlive(size)
}

// SetStretch sets the stretch field of a font description.
//
// The pango.Stretch field specifies how narrow or wide the font should be.
func (desc *FontDescription) SetStretch(stretch Stretch) {
	var _arg0 *C.PangoFontDescription // out
	var _arg1 C.PangoStretch          // out

	_arg0 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc)))
	_arg1 = C.PangoStretch(stretch)

	C.pango_font_description_set_stretch(_arg0, _arg1)
	runtime.KeepAlive(desc)
	runtime.KeepAlive(stretch)
}

// SetStyle sets the style field of a PangoFontDescription.
//
// The pango.Style enumeration describes whether the font is slanted and the
// manner in which it is slanted; it can be either NGO_STYLE_NORMAL,
// NGO_STYLE_ITALIC, or NGO_STYLE_OBLIQUE.
//
// Most fonts will either have a italic style or an oblique style, but not both,
// and font matching in Pango will match italic specifications with oblique
// fonts and vice-versa if an exact match is not found.
func (desc *FontDescription) SetStyle(style Style) {
	var _arg0 *C.PangoFontDescription // out
	var _arg1 C.PangoStyle            // out

	_arg0 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc)))
	_arg1 = C.PangoStyle(style)

	C.pango_font_description_set_style(_arg0, _arg1)
	runtime.KeepAlive(desc)
	runtime.KeepAlive(style)
}

// SetVariant sets the variant field of a font description.
//
// The pango.Variant can either be PANGO_VARIANT_NORMAL or
// PANGO_VARIANT_SMALL_CAPS.
func (desc *FontDescription) SetVariant(variant Variant) {
	var _arg0 *C.PangoFontDescription // out
	var _arg1 C.PangoVariant          // out

	_arg0 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc)))
	_arg1 = C.PangoVariant(variant)

	C.pango_font_description_set_variant(_arg0, _arg1)
	runtime.KeepAlive(desc)
	runtime.KeepAlive(variant)
}

// SetVariations sets the variations field of a font description.
//
// OpenType font variations allow to select a font instance by specifying values
// for a number of axes, such as width or weight.
//
// The format of the variations string is
//
//    AXIS1=VALUE,AXIS2=VALUE...
//
// with each AXIS a 4 character tag that identifies a font axis, and each VALUE
// a floating point number. Unknown axes are ignored, and values are clamped to
// their allowed range.
//
// Pango does not currently have a way to find supported axes of a font. Both
// harfbuzz or freetype have API for this.
func (desc *FontDescription) SetVariations(variations string) {
	var _arg0 *C.PangoFontDescription // out
	var _arg1 *C.char                 // out

	_arg0 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc)))
	_arg1 = (*C.char)(unsafe.Pointer(C.CString(variations)))
	defer C.free(unsafe.Pointer(_arg1))

	C.pango_font_description_set_variations(_arg0, _arg1)
	runtime.KeepAlive(desc)
	runtime.KeepAlive(variations)
}

// SetVariationsStatic sets the variations field of a font description.
//
// This is like pango.FontDescription.SetVariations(), except that no copy of
// variations is made. The caller must make sure that the string passed in stays
// around until desc has been freed or the name is set again. This function can
// be used if variations is a static string such as a C string literal, or if
// desc is only needed temporarily.
func (desc *FontDescription) SetVariationsStatic(variations string) {
	var _arg0 *C.PangoFontDescription // out
	var _arg1 *C.char                 // out

	_arg0 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc)))
	_arg1 = (*C.char)(unsafe.Pointer(C.CString(variations)))
	defer C.free(unsafe.Pointer(_arg1))

	C.pango_font_description_set_variations_static(_arg0, _arg1)
	runtime.KeepAlive(desc)
	runtime.KeepAlive(variations)
}

// SetWeight sets the weight field of a font description.
//
// The weight field specifies how bold or light the font should be. In addition
// to the values of the pango.Weight enumeration, other intermediate numeric
// values are possible.
func (desc *FontDescription) SetWeight(weight Weight) {
	var _arg0 *C.PangoFontDescription // out
	var _arg1 C.PangoWeight           // out

	_arg0 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc)))
	_arg1 = C.PangoWeight(weight)

	C.pango_font_description_set_weight(_arg0, _arg1)
	runtime.KeepAlive(desc)
	runtime.KeepAlive(weight)
}

// ToFilename creates a filename representation of a font description.
//
// The filename is identical to the result from calling
// pango.FontDescription.ToString(), but with underscores instead of characters
// that are untypical in filenames, and in lower case only.
func (desc *FontDescription) ToFilename() string {
	var _arg0 *C.PangoFontDescription // out
	var _cret *C.char                 // in

	_arg0 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc)))

	_cret = C.pango_font_description_to_filename(_arg0)
	runtime.KeepAlive(desc)

	var _utf8 string // out

	_utf8 = C.GoString((*C.gchar)(unsafe.Pointer(_cret)))
	defer C.free(unsafe.Pointer(_cret))

	return _utf8
}

// String creates a string representation of a font description.
//
// See pango.FontDescription.FromString for a description of the format of the
// string representation. The family list in the string description will only
// have a terminating comma if the last word of the list is a valid style
// option.
func (desc *FontDescription) String() string {
	var _arg0 *C.PangoFontDescription // out
	var _cret *C.char                 // in

	_arg0 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc)))

	_cret = C.pango_font_description_to_string(_arg0)
	runtime.KeepAlive(desc)

	var _utf8 string // out

	_utf8 = C.GoString((*C.gchar)(unsafe.Pointer(_cret)))
	defer C.free(unsafe.Pointer(_cret))

	return _utf8
}

// UnsetFields unsets some of the fields in a PangoFontDescription.
//
// The unset fields will get back to their default values.
func (desc *FontDescription) UnsetFields(toUnset FontMask) {
	var _arg0 *C.PangoFontDescription // out
	var _arg1 C.PangoFontMask         // out

	_arg0 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc)))
	_arg1 = C.PangoFontMask(toUnset)

	C.pango_font_description_unset_fields(_arg0, _arg1)
	runtime.KeepAlive(desc)
	runtime.KeepAlive(toUnset)
}

// FontDescriptionFromString creates a new font description from a string
// representation.
//
// The string must have the form
//
//    "\[FAMILY-LIST] \[STYLE-OPTIONS] \[SIZE] \[VARIATIONS]",
//
// where FAMILY-LIST is a comma-separated list of families optionally terminated
// by a comma, STYLE_OPTIONS is a whitespace-separated list of words where each
// word describes one of style, variant, weight, stretch, or gravity, and SIZE
// is a decimal number (size in points) or optionally followed by the unit
// modifier "px" for absolute size. VARIATIONS is a comma-separated list of font
// variation specifications of the form "\axis=value" (the = sign is optional).
//
// The following words are understood as styles: "Normal", "Roman", "Oblique",
// "Italic".
//
// The following words are understood as variants: "Small-Caps".
//
// The following words are understood as weights: "Thin", "Ultra-Light",
// "Extra-Light", "Light", "Semi-Light", "Demi-Light", "Book", "Regular",
// "Medium", "Semi-Bold", "Demi-Bold", "Bold", "Ultra-Bold", "Extra-Bold",
// "Heavy", "Black", "Ultra-Black", "Extra-Black".
//
// The following words are understood as stretch values: "Ultra-Condensed",
// "Extra-Condensed", "Condensed", "Semi-Condensed", "Semi-Expanded",
// "Expanded", "Extra-Expanded", "Ultra-Expanded".
//
// The following words are understood as gravity values: "Not-Rotated", "South",
// "Upside-Down", "North", "Rotated-Left", "East", "Rotated-Right", "West".
//
// Any one of the options may be absent. If FAMILY-LIST is absent, then the
// family_name field of the resulting font description will be initialized to
// NULL. If STYLE-OPTIONS is missing, then all style options will be set to the
// default values. If SIZE is missing, the size in the resulting font
// description will be set to 0.
//
// A typical example:
//
//    "Cantarell Italic Light 15 \wght=200".
//
// The function takes the following parameters:
//
//    - str: string representation of a font description.
//
func FontDescriptionFromString(str string) *FontDescription {
	var _arg1 *C.char                 // out
	var _cret *C.PangoFontDescription // in

	_arg1 = (*C.char)(unsafe.Pointer(C.CString(str)))
	defer C.free(unsafe.Pointer(_arg1))

	_cret = C.pango_font_description_from_string(_arg1)
	runtime.KeepAlive(str)

	var _fontDescription *FontDescription // out

	_fontDescription = (*FontDescription)(gextras.NewStructNative(unsafe.Pointer(_cret)))
	runtime.SetFinalizer(
		gextras.StructIntern(unsafe.Pointer(_fontDescription)),
		func(intern *struct{ C unsafe.Pointer }) {
			C.pango_font_description_free((*C.PangoFontDescription)(intern.C))
		},
	)

	return _fontDescription
}

// FontMetrics: PangoFontMetrics structure holds the overall metric information
// for a font.
//
// The information in a PangoFontMetrics structure may be restricted to a
// script. The fields of this structure are private to implementations of a font
// backend. See the documentation of the corresponding getters for documentation
// of their meaning.
//
// An instance of this type is always passed by reference.
type FontMetrics struct {
	*fontMetrics
}

// fontMetrics is the struct that's finalized.
type fontMetrics struct {
	native *C.PangoFontMetrics
}

func marshalFontMetrics(p uintptr) (interface{}, error) {
	b := externglib.ValueFromNative(unsafe.Pointer(p)).Boxed()
	return &FontMetrics{&fontMetrics{(*C.PangoFontMetrics)(b)}}, nil
}

// ApproximateCharWidth gets the approximate character width for a font metrics
// structure.
//
// This is merely a representative value useful, for example, for determining
// the initial size for a window. Actual characters in text will be wider and
// narrower than this.
func (metrics *FontMetrics) ApproximateCharWidth() int {
	var _arg0 *C.PangoFontMetrics // out
	var _cret C.int               // in

	_arg0 = (*C.PangoFontMetrics)(gextras.StructNative(unsafe.Pointer(metrics)))

	_cret = C.pango_font_metrics_get_approximate_char_width(_arg0)
	runtime.KeepAlive(metrics)

	var _gint int // out

	_gint = int(_cret)

	return _gint
}

// ApproximateDigitWidth gets the approximate digit width for a font metrics
// structure.
//
// This is merely a representative value useful, for example, for determining
// the initial size for a window. Actual digits in text can be wider or narrower
// than this, though this value is generally somewhat more accurate than the
// result of pango_font_metrics_get_approximate_char_width() for digits.
func (metrics *FontMetrics) ApproximateDigitWidth() int {
	var _arg0 *C.PangoFontMetrics // out
	var _cret C.int               // in

	_arg0 = (*C.PangoFontMetrics)(gextras.StructNative(unsafe.Pointer(metrics)))

	_cret = C.pango_font_metrics_get_approximate_digit_width(_arg0)
	runtime.KeepAlive(metrics)

	var _gint int // out

	_gint = int(_cret)

	return _gint
}

// Ascent gets the ascent from a font metrics structure.
//
// The ascent is the distance from the baseline to the logical top of a line of
// text. (The logical top may be above or below the top of the actual drawn ink.
// It is necessary to lay out the text to figure where the ink will be.).
func (metrics *FontMetrics) Ascent() int {
	var _arg0 *C.PangoFontMetrics // out
	var _cret C.int               // in

	_arg0 = (*C.PangoFontMetrics)(gextras.StructNative(unsafe.Pointer(metrics)))

	_cret = C.pango_font_metrics_get_ascent(_arg0)
	runtime.KeepAlive(metrics)

	var _gint int // out

	_gint = int(_cret)

	return _gint
}

// Descent gets the descent from a font metrics structure.
//
// The descent is the distance from the baseline to the logical bottom of a line
// of text. (The logical bottom may be above or below the bottom of the actual
// drawn ink. It is necessary to lay out the text to figure where the ink will
// be.).
func (metrics *FontMetrics) Descent() int {
	var _arg0 *C.PangoFontMetrics // out
	var _cret C.int               // in

	_arg0 = (*C.PangoFontMetrics)(gextras.StructNative(unsafe.Pointer(metrics)))

	_cret = C.pango_font_metrics_get_descent(_arg0)
	runtime.KeepAlive(metrics)

	var _gint int // out

	_gint = int(_cret)

	return _gint
}

// Height gets the line height from a font metrics structure.
//
// The line height is the distance between successive baselines in wrapped text.
//
// If the line height is not available, 0 is returned.
func (metrics *FontMetrics) Height() int {
	var _arg0 *C.PangoFontMetrics // out
	var _cret C.int               // in

	_arg0 = (*C.PangoFontMetrics)(gextras.StructNative(unsafe.Pointer(metrics)))

	_cret = C.pango_font_metrics_get_height(_arg0)
	runtime.KeepAlive(metrics)

	var _gint int // out

	_gint = int(_cret)

	return _gint
}

// StrikethroughPosition gets the suggested position to draw the strikethrough.
//
// The value returned is the distance *above* the baseline of the top of the
// strikethrough.
func (metrics *FontMetrics) StrikethroughPosition() int {
	var _arg0 *C.PangoFontMetrics // out
	var _cret C.int               // in

	_arg0 = (*C.PangoFontMetrics)(gextras.StructNative(unsafe.Pointer(metrics)))

	_cret = C.pango_font_metrics_get_strikethrough_position(_arg0)
	runtime.KeepAlive(metrics)

	var _gint int // out

	_gint = int(_cret)

	return _gint
}

// StrikethroughThickness gets the suggested thickness to draw for the
// strikethrough.
func (metrics *FontMetrics) StrikethroughThickness() int {
	var _arg0 *C.PangoFontMetrics // out
	var _cret C.int               // in

	_arg0 = (*C.PangoFontMetrics)(gextras.StructNative(unsafe.Pointer(metrics)))

	_cret = C.pango_font_metrics_get_strikethrough_thickness(_arg0)
	runtime.KeepAlive(metrics)

	var _gint int // out

	_gint = int(_cret)

	return _gint
}

// UnderlinePosition gets the suggested position to draw the underline.
//
// The value returned is the distance *above* the baseline of the top of the
// underline. Since most fonts have underline positions beneath the baseline,
// this value is typically negative.
func (metrics *FontMetrics) UnderlinePosition() int {
	var _arg0 *C.PangoFontMetrics // out
	var _cret C.int               // in

	_arg0 = (*C.PangoFontMetrics)(gextras.StructNative(unsafe.Pointer(metrics)))

	_cret = C.pango_font_metrics_get_underline_position(_arg0)
	runtime.KeepAlive(metrics)

	var _gint int // out

	_gint = int(_cret)

	return _gint
}

// UnderlineThickness gets the suggested thickness to draw for the underline.
func (metrics *FontMetrics) UnderlineThickness() int {
	var _arg0 *C.PangoFontMetrics // out
	var _cret C.int               // in

	_arg0 = (*C.PangoFontMetrics)(gextras.StructNative(unsafe.Pointer(metrics)))

	_cret = C.pango_font_metrics_get_underline_thickness(_arg0)
	runtime.KeepAlive(metrics)

	var _gint int // out

	_gint = int(_cret)

	return _gint
}
